/***************************************************************************
                          grabdvd.cpp  -  description
                             -------------------
    begin                : mer nov 27 2002
    copyright            : (C) 2002 by Francesco Mezzanotte
    email                : francesco.mezzanotte@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmediagrab.h"
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qstring.h>
#include <qmultilineedit.h>
#include <qspinbox.h>
#include <kfiledialog.h>
#include <qlineedit.h>
#include <kprocess.h>
#include <klocale.h>
#include <krun.h>


void KMediaGrab::grabDvdStart()
{

    ButtonDvdStart->setDisabled(true);
    ButtonDvdStop->setEnabled(true);
    BrowserDvd->setText("");
    grabDvdCmd.clearArguments();

    // Check for a valid file://
    if(LineDvdOutput->text()=="")
    {

          ButtonDvdStart->setEnabled(true);
          ButtonDvdStop->setDisabled(true);
          BrowserDvd->append(i18n("no file selected"));
          return;

    }

    grabDvdCmd<<"mencoder"<<"-dvd";
                                                                                                            //           ADD DVDSETTINGS
    grabDvdCmd<<ComboDvdTitle->text();
                                                                                                                                 
    if(ComboDvdLang->currentItem()!=0)
    {
    
        grabDvdCmd<<"-alang";
        grabDvdCmd<<ComboDvdLang->currentText();

    }


    if(CheckDvdSub->isChecked())
    {

        grabDvdCmd<<"-sid";
        grabDvdCmd<<ComboDvdSub->currentText();

    }
    
    grabDvdCmd<<"-ovc";

    switch(ComboDvdVideoCodec->currentItem())
    {

        case 0:
                  grabDvdCmd<<"lavc"<<"-lavcopts";

                  switch(ComboDvdVideoCodecLavc->currentItem())
                  {

                      case 0:
                                stringDvdVideo="vcodec=mpeg4";
                                stringDvdVideo+=":vbitrate=";
                                stringDvdVideo+=SpinDvdVideoBr->text();
                                break;

                      case 1:
                                stringDvdVideo="vcodec=msmpeg4";
                                stringDvdVideo+=":vbitrate=";
                                stringDvdVideo+=SpinDvdVideoBr->text();
                                break;

                      case 2:
                                stringDvdVideo="vcodec=mjpeg";
                                stringDvdVideo+=":vbitrate=";
                                stringDvdVideo+=SpinDvdVideoBr->text();
                                break;

                      case 3:
                                stringDvdVideo="vcodec=h263p";
                                stringDvdVideo+=":vbitrate=";
                                stringDvdVideo+=SpinDvdVideoBr->text();
                                break;

                      case 4:
                                stringDvdVideo="vcodec=rv10";
                                stringDvdVideo+=":vbitrate=";
                                stringDvdVideo+=SpinDvdVideoBr->text();
                                break;

                      case 5:
                                stringDvdVideo="vcodec=mpeg1video";
                                stringDvdVideo+=":vbitrate=";
                                stringDvdVideo+=SpinDvdVideoBr->text();
                                break;

                  }

                  if (CheckDvdLavcVhq->isChecked())
                  {

                      stringDvdVideo+=":vhq";

                  }

                  grabDvdCmd<<stringDvdVideo;
                  break;

        case 1:
                  grabDvdCmd<<"xvid"<<"-xvidencopts";
                  stringDvdVideo="bitrate=";
                  stringDvdVideo+=SpinDvdVideoBr->text();
                  stringDvdVideo+=":me_quality=";
                  dvdDivxQuality.setNum(ComboDvdDivx4Quality->currentItem());
                  stringDvdVideo+=dvdDivxQuality;
                  grabDvdCmd<<stringDvdVideo;
                  break;

        case 2:
                  grabDvdCmd<<"copy";
                  break;

    }

    //ADD AUDIO SETTINGS

    if(!CheckDvdNoaudio->isChecked())
    {

        grabDvdCmd<<"-oac";

        switch(ComboDvdAudioCodec->currentItem())
        {

              case 0:

                        grabDvdCmd<<"mp3lame"<<"-lameopts";

                       switch(ComboDvdAudioBitrateType->currentItem())
                       {

                           case 0:
                                     stringDvdAudio="abr";
                                     stringDvdAudio+=":aq=";
                                     abrDvdAlgoQuality.setNum(ComboDvdAlgoQuality->currentItem());
                                     stringDvdAudio+=abrDvdAlgoQuality;
                                     stringDvdAudio+=":vol=";
                                     stringDvdAudio+=SpinDvdVolumeGain->text();
                                     stringDvdAudio+=":br=";
                                     stringDvdAudio+=ComboDvdAudioBitrate->currentText();
                                     break;

                           case 1:
                                     stringDvdAudio="cbr";
                                     stringDvdAudio+=":aq=";
                                     cbrDvdAlgoQuality.setNum(ComboDvdAlgoQuality->currentItem());
                                     stringDvdAudio+=cbrDvdAlgoQuality;
                                     stringDvdAudio+=":vol=";
                                     stringDvdAudio+=SpinDvdVolumeGain->text();
                                     stringDvdAudio+=":br=";
                                     stringDvdAudio+=ComboDvdAudioBitrate->currentText();
                                     break;

                           case 2:
                                     stringDvdAudio="vbr=";
                                     dvdVbrType.setNum(ComboDvdVbrType->currentItem());
                                     stringDvdAudio+=dvdVbrType;
                                     stringDvdAudio+=":aq=";
                                     vbrDvdAlgoQuality.setNum(ComboDvdAlgoQuality->currentItem());
                                     stringDvdAudio+=vbrDvdAlgoQuality;
                                     stringDvdAudio+=":vol=";
                                     stringDvdAudio+=SpinDvdVolumeGain->text();
                                     stringDvdAudio+=":q=";
                                     dvdVbrQuality.setNum(ComboDvdVbrQuality->currentItem());
                                     stringDvdAudio+=dvdVbrQuality;
                                     break;

                       }

                       switch(ComboDvdAudioMode->currentItem())
                       {

                              case 0:
                                        break;

                              case 1:
                                        stringDvdAudio+=":mode=0";
                                        break;

                              case 2:
                                        stringDvdAudio+=":mode=1";
                                        break;

                              case 3:
                                        stringDvdAudio+=":mode=2";
                                        break;

                              case 4:
                                        stringDvdAudio+=":mode=3";
                                        break;


                       }

                       grabDvdCmd<<stringDvdAudio;
                       break;

        case 1:
                  grabDvdCmd<<"copy";
                  break;

        }

    }

    else
    {

        grabDvdCmd<<"-nosound";

    }

   

                                                                                                                              //             VIDEO SCALING

    if(ComboDvdVideoCodec->currentItem()!=2 && CheckDvdVideoScale->isChecked())
    {

        grabDvdCmd<<"-vop scale -zoom -xy"<<ComboDvdScaleVideo->currentText();

    }
    
    grabDvdCmd<<"-o"<<LineDvdOutput->text();
    
    grabDvdCmd.start( KProcess::NotifyOnExit , KProcess::AllOutput) ;
}

void KMediaGrab::grabDvdGetStdout(KProcess *proc, char *buffer, int buflen )
{

    QString out(buffer);
    out.truncate(buflen);
    BrowserDvd->append( out );

}

void KMediaGrab::grabDvdGetStderr(KProcess *proc, char *buffer, int buflen )
{

    QString out(buffer);
    out.truncate(buflen);
    BrowserDvd->append( out );

}

void KMediaGrab::grabDvdProcessEnd( KProcess *)
{

    grabDvdCmd.kill();
    ButtonDvdStart->setEnabled(true);
    ButtonDvdStop->setDisabled(true);

}

void KMediaGrab::grabDvdStop()
{

    grabDvdCmd.kill();
    ButtonDvdStart->setEnabled(true);
    ButtonDvdStop->setDisabled(true);

}


void KMediaGrab::switchDvdVideoCodec(int VideoCodec)
{

    switch(VideoCodec)
    {

        case 0:
                  ComboDvdVideoCodecLavc->setEnabled(true);
                  ComboDvdDivx4Quality->setDisabled(true);
                  CheckDvdLavcVhq->setEnabled(true);
                  SpinDvdVideoBr->setEnabled(true);
                  CheckDvdVideoScale->setEnabled(true);
                  
                  if(CheckDvdVideoScale->isChecked())
                  {
                    
                      ComboDvdScaleVideo->setEnabled(true);

                  }
                  
                  break;

        case 1:
                  ComboDvdVideoCodecLavc->setDisabled(true);
                  ComboDvdDivx4Quality->setEnabled(true);
                  CheckDvdLavcVhq->setDisabled(true);
                  SpinDvdVideoBr->setEnabled(true);
                  CheckDvdVideoScale->setEnabled(true);
                  
                  if(CheckDvdVideoScale->isChecked())
                  {

                      ComboDvdScaleVideo->setEnabled(true);

                  }
                  
                  break;

        case 2:
                  ComboDvdVideoCodecLavc->setDisabled(true);
                  ComboDvdDivx4Quality->setDisabled(true);
                  CheckDvdLavcVhq->setDisabled(true);
                  SpinDvdVideoBr->setDisabled(true);
                  CheckDvdVideoScale->setDisabled(true);
                  ComboDvdScaleVideo->setDisabled(true);
                  break;



    }

}

void KMediaGrab::switchDvdAudioCodec(int AudioCodec)
{

    switch(AudioCodec)
    {

        case 0:
                  ComboDvdAudioBitrateType->setEnabled(true);
                  ComboDvdAudioBitrate->setEnabled(true);
                  ComboDvdAlgoQuality->setEnabled(true);
                  SpinDvdVolumeGain->setEnabled(true);
                  ComboDvdAudioMode->setEnabled(true);
                  if( ComboDvdAudioBitrateType->currentItem()==2)
                  {

                      ComboDvdVbrType->setEnabled(true);
                      ComboDvdVbrQuality->setEnabled(true);
                  }

                  break;

        case 1:
                  ComboDvdAudioBitrateType->setDisabled(true);
                  ComboDvdAudioBitrate->setDisabled(true);
                  ComboDvdAlgoQuality->setDisabled(true);
                  SpinDvdVolumeGain->setDisabled(true);
                  ComboDvdAudioMode->setDisabled(true);
                  ComboDvdVbrType->setDisabled(true);
                  ComboDvdVbrQuality->setDisabled(true);
                  break;

    }

}

void KMediaGrab::toggleDvdVbr(int BitrateType)
{

    switch(BitrateType)
    {

        case 0:
                  ComboDvdVbrType->setDisabled(true);
                  ComboDvdVbrQuality->setDisabled(true);
                  break;

        case 1:
                  ComboDvdVbrType->setDisabled(true);
                  ComboDvdVbrQuality->setDisabled(true);
                  break;

        case 2:
                  ComboDvdVbrType->setEnabled(true);
                  ComboDvdVbrQuality->setEnabled(true);
                  break;


    }

}

void KMediaGrab::toggleDvdNoAudio(bool noAudio)
{

    if(noAudio)
    {

        ComboDvdAudioBitrateType->setDisabled(true);
        ComboDvdAudioBitrate->setDisabled(true);
        ComboDvdAlgoQuality->setDisabled(true);
        SpinDvdVolumeGain->setDisabled(true);
        ComboDvdAudioMode->setDisabled(true);
        ComboDvdVbrType->setDisabled(true);
        ComboDvdVbrQuality->setDisabled(true);
        ComboDvdAudioCodec->setDisabled(true);
    }

    else
    {

        ComboDvdAudioBitrateType->setEnabled(true);
        ComboDvdAudioBitrate->setEnabled(true);
        ComboDvdAlgoQuality->setEnabled(true);
        SpinDvdVolumeGain->setEnabled(true);
        ComboDvdAudioMode->setEnabled(true);
        if( ComboDvdAudioBitrateType->currentItem()==2)
        {

        ComboDvdVbrType->setEnabled(true);
        ComboDvdVbrQuality->setEnabled(true);
        }

        ComboDvdAudioCodec->setEnabled(true);

    }

}

void KMediaGrab::getDvdOutput()
{

    fileDvdOutput = KFileDialog::getSaveFileName( QString::null , "*" , this , i18n("Save to..."));
    LineDvdOutput->setText(fileDvdOutput);

}

void KMediaGrab::playDvdOutput()
{

    KRun* RunDvd =new KRun(KURL(LineDvdOutput->text()));

}



void KMediaGrab::toggleDvdVideoScale()
{

    if(CheckDvdVideoScale->isChecked())
    {

        ComboDvdScaleVideo->setEnabled(true);

    }

    else

        ComboDvdScaleVideo->setDisabled(true);

}


void KMediaGrab::toggleDvdSub(bool)
{

    if(CheckDvdSub->isChecked())
    {

        ComboDvdSub->setEnabled(true);

    }

    else

        ComboDvdSub->setDisabled(true);

}







