/***************************************************************************
                          grabtv.cpp  -  description
                             -------------------
    begin                : mar nov 19 2002
    copyright            : (C) 2002 by Francesco Mezzanotte
    email                : francesco.mezzanotte@inwind.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmediagrab.h"
#include <qpushbutton.h>
#include <qstring.h>
#include <qmultilineedit.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <kfiledialog.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <kprocess.h>
#include <klocale.h>
#include <krun.h>



void KMediaGrab::grabTvStart()
{

    ButtonTvStart->setDisabled(true);
    ButtonTvStop->setEnabled(true);
    BrowserTv->setText("");
    grabTvCmd.clearArguments();
    
    // Check for a valid file://
    if(LineTvOutput->text()=="")
    {

          ButtonTvStart->setEnabled(true);
          ButtonTvStop->setDisabled(true);
          BrowserTv->append(i18n("no file selected"));
          return;

    }
    
    grabTvCmd<<"mencoder"<<"-tv";

    //ADD TV SETTINGS
    
    stringTvSettings="on:driver=";
    stringTvSettings+=ComboTvDriver->currentText();
    stringTvSettings+=":input=";
    tvInput.setNum(ComboTvInput->currentItem());
    stringTvSettings+=tvInput;
    stringTvSettings+=":norm=";
    stringTvSettings+=ComboTvSystem->currentText();
    stringTvSettings+=":chanlist=";
    stringTvSettings+=ComboChannelList->currentText();
    stringTvSettings+=":channel=";
    stringTvSettings+=ComboTvChannel->currentText();

    if(CheckTvNoaudio->isChecked())
    {

           stringTvSettings+=":noaudio";

    }

    switch(ComboTvSize->currentItem())
    {

        case 0:
                  stringTvSettings+=":width=768:height=576";
                  break;

        case 1:
                  stringTvSettings+=":width=640:height=480";
                  break;

        case 2:
                  stringTvSettings+=":width=576:height=432";
                  break;

        case 3:
                  stringTvSettings+=":width=496:height=372";
                  break;

        case 4:
                  stringTvSettings+=":width=384:height=288";
                  break;
    
    }
    
    grabTvCmd<<stringTvSettings;
    //ADD VIDEO SETTINGS

    grabTvCmd<<"-ovc";

    switch(ComboTvVideoCodec->currentItem())
    {

        case 0:
                  grabTvCmd<<"lavc"<<"-lavcopts";

                  switch(ComboTvVideoCodecLavc->currentItem())
                  {

                      case 0:
                                stringTvVideo="vcodec=mpeg4";
                                stringTvVideo+=":vbitrate=";
                                stringTvVideo+=SpinTvVideoBr->text();
                                break;

                      case 1:
                                stringTvVideo="vcodec=msmpeg4";
                                stringTvVideo+=":vbitrate=";
                                stringTvVideo+=SpinTvVideoBr->text();
                                break;

                      case 2:
                                stringTvVideo="vcodec=mjpeg";
                                stringTvVideo+=":vbitrate=";
                                stringTvVideo+=SpinTvVideoBr->text();
                                break;

                      case 3:
                                stringTvVideo="vcodec=h263p";
                                stringTvVideo+=":vbitrate=";
                                stringTvVideo+=SpinTvVideoBr->text();
                                break;

                      case 4:
                                stringTvVideo="vcodec=rv10";
                                stringTvVideo+=":vbitrate=";
                                stringTvVideo+=SpinTvVideoBr->text();
                                break;

                      case 5:
                                stringTvVideo="vcodec=mpeg1video";
                                stringTvVideo+=":vbitrate=";
                                stringTvVideo+=SpinTvVideoBr->text();
                                break;                  

                  }
                  
                  if (CheckTvLavcVhq->isChecked())
                  {

                      stringTvVideo+=":vhq";

                  }

                  grabTvCmd<<stringTvVideo;
                  break;

        case 1:
                  grabTvCmd<<"xvid"<<"-xvidencopts";
                  stringTvVideo="bitrate=";
                  stringTvVideo+=SpinTvVideoBr->text();
                  stringTvVideo+=":me_quality=";
                  tvDivxQuality.setNum(ComboTvDivx4Quality->currentItem()); 
                  stringTvVideo+=tvDivxQuality;         
                  grabTvCmd<<stringTvVideo;
                  break;

        case 2:
                  grabTvCmd<<"copy";
                  break;

    }
       
    //ADD AUDIO SETTINGS
    
    if(!CheckTvNoaudio->isChecked())
    {
      
        grabTvCmd<<"-oac";

        switch(ComboTvAudioCodec->currentItem())
        {
          
              case 0:

                        grabTvCmd<<"mp3lame"<<"-lameopts";

                       switch(ComboTvAudioBitrateType->currentItem())
                       {

                           case 0:
                                     stringTvAudio="abr";
                                     stringTvAudio+=":aq=";
                                     abrTvAlgoQuality.setNum(ComboTvAlgoQuality->currentItem());
                                     stringTvAudio+=abrTvAlgoQuality;
                                     stringTvAudio+=":vol=";
                                     stringTvAudio+=SpinTvVolumeGain->text();
                                     stringTvAudio+=":br=";
                                     stringTvAudio+=ComboTvAudioBitrate->currentText();
                                     break;

                           case 1:
                                     stringTvAudio="cbr";
                                     stringTvAudio+=":aq=";
                                     cbrTvAlgoQuality.setNum(ComboTvAlgoQuality->currentItem());
                                     stringTvAudio+=cbrTvAlgoQuality;
                                     stringTvAudio+=":vol=";
                                     stringTvAudio+=SpinTvVolumeGain->text();
                                     stringTvAudio+=":br=";
                                     stringTvAudio+=ComboTvAudioBitrate->currentText();
                                     break;

                           case 2:
                                     stringTvAudio="vbr=";
                                     tvVbrType.setNum(ComboTvVbrType->currentItem());
                                     stringTvAudio+=tvVbrType;
                                     stringTvAudio+=":aq=";
                                     vbrTvAlgoQuality.setNum(ComboTvAlgoQuality->currentItem());
                                     stringTvAudio+=vbrTvAlgoQuality;
                                     stringTvAudio+=":vol=";
                                     stringTvAudio+=SpinTvVolumeGain->text();
                                     stringTvAudio+=":q=";
                                     tvVbrQuality.setNum(ComboTvVbrQuality->currentItem());
                                     stringTvAudio+=tvVbrQuality;
                                     break;

                       }

                       switch(ComboTvAudioMode->currentItem())
                       {

                              case 0:
                                        break;

                              case 1:
                                        stringTvAudio+=":mode=0";
                                        break;

                              case 2:
                                        stringTvAudio+=":mode=1";
                                        break;

                              case 3:
                                        stringTvAudio+=":mode=2";
                                        break;

                              case 4:
                                        stringTvAudio+=":mode=3";
                                        break;


                       }
                       
                       grabTvCmd<<stringTvAudio;
                       break;

        case 1:
                  grabTvCmd<<"copy";
                  break;
                  
        }
    
    }

    else
    {

        grabTvCmd<<"-nosound";
        
    }
      
    grabTvCmd<<"-frames";
    tvRecTime.setNum(1500*SpinTvRecTime->value());
    grabTvCmd<<tvRecTime;
    
    grabTvCmd<<"-o"<<LineTvOutput->text();    
    
    grabTvCmd.start( KProcess::NotifyOnExit , KProcess::AllOutput) ;
}

void KMediaGrab::grabTvGetStdout(KProcess *proc, char *buffer, int buflen )
{

    QString out(buffer);
    out.truncate(buflen);
    BrowserTv->append( out );

}

void KMediaGrab::grabTvGetStderr(KProcess *proc, char *buffer, int buflen )
{

    QString out(buffer);
    out.truncate(buflen);
    BrowserTv->append( out );

}

void KMediaGrab::grabTvProcessEnd( KProcess *)
{

    grabTvCmd.kill();
    ButtonTvStart->setEnabled(true);
    ButtonTvStop->setDisabled(true);

}

void KMediaGrab::grabTvStop()
{
    
    grabTvCmd.kill();
    ButtonTvStart->setEnabled(true);
    ButtonTvStop->setDisabled(true);
    
}


void KMediaGrab::switchTvVideoCodec(int VideoCodec)
{

    switch(VideoCodec)
    {

        case 0:
                  ComboTvVideoCodecLavc->setEnabled(true);
                  ComboTvDivx4Quality->setDisabled(true);
                  CheckTvLavcVhq->setEnabled(true);
                  SpinTvVideoBr->setEnabled(true);
                  break;

        case 1:
                  ComboTvVideoCodecLavc->setDisabled(true);
                  ComboTvDivx4Quality->setEnabled(true);
                  CheckTvLavcVhq->setDisabled(true);
                  SpinTvVideoBr->setEnabled(true);
                  break;

        case 2:
                  ComboTvVideoCodecLavc->setDisabled(true);
                  ComboTvDivx4Quality->setDisabled(true);
                  CheckTvLavcVhq->setDisabled(true);
                  SpinTvVideoBr->setDisabled(true);
                  break;
                  
                  

    }

}

void KMediaGrab::switchTvAudioCodec(int AudioCodec)
{

    switch(AudioCodec)
    {

        case 0:
                  ComboTvAudioBitrateType->setEnabled(true);
                  ComboTvAudioBitrate->setEnabled(true);
                  ComboTvAlgoQuality->setEnabled(true);
                  SpinTvVolumeGain->setEnabled(true);
                  ComboTvAudioMode->setEnabled(true);
                  if( ComboTvAudioBitrateType->currentItem()==2)
                  {
                    
                      ComboTvVbrType->setEnabled(true);
                      ComboTvVbrQuality->setEnabled(true);
                  }
                  
                  break;

        case 1:
                  ComboTvAudioBitrateType->setDisabled(true);
                  ComboTvAudioBitrate->setDisabled(true);
                  ComboTvAlgoQuality->setDisabled(true);
                  SpinTvVolumeGain->setDisabled(true);
                  ComboTvAudioMode->setDisabled(true);
                  ComboTvVbrType->setDisabled(true);
                  ComboTvVbrQuality->setDisabled(true);
                  break;

    }

}

void KMediaGrab::toggleTvVbr(int BitrateType)
{

    switch(BitrateType)
    {

        case 0:
                  ComboTvVbrType->setDisabled(true);
                  ComboTvVbrQuality->setDisabled(true);
                  break;

        case 1:
                  ComboTvVbrType->setDisabled(true);
                  ComboTvVbrQuality->setDisabled(true);
                  break;

        case 2:
                  ComboTvVbrType->setEnabled(true);
                  ComboTvVbrQuality->setEnabled(true);
                  break;
       

    }

}

void KMediaGrab::toggleTvNoAudio(bool noAudio)
{

    if(noAudio)
    {

        ComboTvAudioBitrateType->setDisabled(true);
        ComboTvAudioBitrate->setDisabled(true);
        ComboTvAlgoQuality->setDisabled(true);
        SpinTvVolumeGain->setDisabled(true);
        ComboTvAudioMode->setDisabled(true);
        ComboTvVbrType->setDisabled(true);
        ComboTvVbrQuality->setDisabled(true);
        ComboTvAudioCodec->setDisabled(true);
    }

    else
    {

        ComboTvAudioBitrateType->setEnabled(true);
        ComboTvAudioBitrate->setEnabled(true);
        ComboTvAlgoQuality->setEnabled(true);
        SpinTvVolumeGain->setEnabled(true);
        ComboTvAudioMode->setEnabled(true);
        if( ComboTvAudioBitrateType->currentItem()==2)
        {

        ComboTvVbrType->setEnabled(true);
        ComboTvVbrQuality->setEnabled(true);
        }

        ComboTvAudioCodec->setEnabled(true);

    }

}

void KMediaGrab::getTvOutput()
{

    fileTvOutput = KFileDialog::getSaveFileName( QString::null , "*" , this , i18n("Save to..."));
    LineTvOutput->setText(fileTvOutput);

}

void KMediaGrab::playTvOutput()
{
    
    KRun* RunTv =new KRun(KURL(LineTvOutput->text()));
    
}


